#include <Adafruit_ESP8266.h>
#include <SoftwareSerial.h>
#include "esp8266.h"

#define IFTTT_SERVER "maker.ifttt.com"
#define IFTTT_EVENT_NAME "EVENT_NAME"
#define IFTTT_SECRET_KEY "*********************"
#define ESP_SSID "YOUR_SSID" // Your network name here
#define ESP_PASS "YOUR_PASSPHRASE" // Your network password here

#define SWITCH_PIN 2

char buff[100];

void setup() {
  Serial.begin(9600);
  if (!esp8266_setup()) {
    Serial.println("Failed to initialize Wifi");
    while(true);
  }
  delay(1000);
  Serial.println("Ready.");
  pinMode(SWITCH_PIN, INPUT_PULLUP);
  esp8266_connectAP(F(ESP_SSID), F(ESP_PASS));
}

void loop() {
  if(!digitalRead(SWITCH_PIN)) {
    Serial.println("*** triggering IFTTT ***");
    if(ifttt_trigger(IFTTT_EVENT_NAME, IFTTT_SECRET_KEY, "111", "222", "333")) {
      delay(10000);
    }
  }
}


int ifttt_trigger(char* event, char* key) {
  return ifttt_trigger(event, key, NULL, NULL, NULL);
}

int ifttt_trigger(char* event, char* key, char* ing1, char* ing2, char* ing3) {
  Serial.println("connecting...");
  if (esp8266_connectTCP(F(IFTTT_SERVER), 80)) {

    Serial.println("connected");
    String url = "/trigger/";
    url += event;
    url += "/with/key/";
    url += key;

    boolean params = false;    
    if(ing1[0] != NULL) {
      url += "?value1=";
      url += ing1;
      params = true;
    }
    if(ing2[0] != NULL) {
      if(!params) {
        url += "?";
      }
      else {
        url += "&";
      }
      url += "value2=";
      url += ing2;
      params = true;
    }
    if(ing3[0] != NULL) {
      if(!params) {
        url += "?";
      }
      else {
        url += "&";
      }
      url += "value3=";
      url += ing3;
      params = true;
    }

    Serial.println(url);
    url.toCharArray(buff, sizeof(buff));
    esp8266_requestURL(buff, "POST");
    delay(10000);
    esp8266_closeTCP();
    return true;
  }
  else {
    Serial.println("connection failed");
    esp8266_closeTCP();
    return false;
  }
}


